@node Tips und Tricks
@chapter Tips und Tricks
@cindex Tips und Tricks

   Diese Sparte ist zunchst leer.  Sollten sich Anfragen und Tips aus dem
hoffentlich  groen  Kreis  von  @file{@sc{RSys}}-Benutzern,  wird sich dieser Bereich
fllen.

   Stop!  Ein paar Tips habe ich schon :-)

@menu
* Batch zum Debuggen von Programmen::
* Das Programm tbreak::
@end menu

@c --------------------------------------
@node Batch zum Debuggen von Programmen
@section Batch zum Debuggen von Programmen
@cindex Batch zum Debuggen von Programmen

@pindex tracer
   Der  folgende  Batch (Name @file{tracer}) war mir beim Testen des Programmes
sehr hilfreich:

@example
.KEY onoff,program/A
.bra @{
.KET @}

if @{ program @} eq ""
   echo "Aufruf: tracer [ON | OFF] [program]"
   quit
endif

if @{ onoff @} eq ON
   assign t: doks:t
   cpu nofastrom
   run >NIL: <NIL: MungWall TASK @{program@}
   run >NIL: <NIL: IO_Torture
   run >NIL: <NIL: enforcer ON
   run sushi <>"CON:0/190//80/Sushi CTRL-E:Empty CTRL-F:File/AUTO/CLOSE"
             ON BUFK=1024
else
   if @{ onoff @} eq OFF
      Utilities:ProgUtils/Sushi/sushi OFF
      run >NIL: <NIL: enforcer OFF
      tbreak IO_Torture
      tbreak MungWall
      cpu fastrom
      assign t: ram:t
   else
      echo "Aufruf: tracer [ON | OFF] <[program]>"
   endif
endif
@end example


@c --------------------------------------
@node Das Programm tbreak
@section Das Programm tbreak
@cindex Das Programm tbreak

   Das  Programm @file{tbreak} sendet einen Break-Signal an den Task, dessen Name
als  Parameter  beim  Aufruf  mit  angegeben  wurde.   Es  ist ein kleines
Programm, da ich mal quick and dirty gehackt habe.  Hier kommt der kleine
Quelltext dazu:
@pindex tbreak

@page
@smallexample
#include <exec/types.h>
#include <exec/execbase.h>

#include <dos/dos.h>
#include <dos/dosextens.h>

#include <clib/dos_protos.h>
#include <clib/exec_protos.h>

#include <stdio.h>
#include <string.h>

#define STRINGEND '\0'

char *
B2CStr(char *ret, BSTR inp)
@{
   register int i;
   char *help = (char *)BADDR(inp);

   for (i = 0; i < *help; i++)
      *(ret + i) = *(help + i + 1);

   *(ret + i) = STRINGEND;

   return (ret);
@}

int
main(int argc,char **argv)
@{
   struct DOSBase *DOSBase = NULL;
   extern struct ExecBase *SysBase;
   int ret = RETURN_FAIL;

   if(DOSBase = (struct DOSBase *)OpenLibrary((STRPTR)"dos.library", 33L))
   @{
      struct Node *node,*membernode[200];
      struct CommandLineInterface *CLI;
      char modname[200];
      int i,j,out;

      if(argc != 2)
         Printf((STRPTR)"Aufruf: %s <taskname>\n",argv[0]);
      else
      @{
         Forbid();
         Disable();

         for (node = SysBase->TaskWait.lh_Head;
              node->ln_Succ&& i < 200; node = node->ln_Succ)
            membernode[i++] = node;

         for (node = SysBase->TaskReady.lh_Head;
              node->ln_Succ && i < 200; node = node->ln_Succ)
            membernode[i++] = node;

         if (i < 200)
            membernode[i++] = &SysBase->ThisTask->tc_Node;

         Enable();

         out = FALSE;

         for (j = 0; j < i && !out && i < 200; j++)
         @{
            struct Process *proc = (struct Process *)membernode[j];
            if(CLI = (struct CommandLineInterface *)BADDR(proc->pr_CLI))
            @{
               B2CStr(modname,CLI->cli_CommandName);
               if (!strcmp(argv[1],modname))
               @{
                  Signal((struct Task *)proc,
                         SIGBREAKF_CTRL_C | SIGBREAKF_CTRL_D |
                         SIGBREAKF_CTRL_E | SIGBREAKF_CTRL_F);
                  out = TRUE;
               @}
            @}
         @}

         Permit();

         if(out == TRUE)
            Printf((STRPTR)"Task with command \'%s\' signaled...\n",argv[1]);
         if(i >= 200)
            PutStr((UBYTE *)"More than 200 tasks read!\n");

         ret = RETURN_OK;
      @}
      CloseLibrary((struct Library *)DOSBase);
   @}

   return(ret);
@}
@end smallexample



